#!BPY
"""
Name: 'Set electro properties...'
Blender: 244
Group: 'Electro'
Tooltip: 'Set electro properties for the selected object'
"""

__author__ = "Matt Handley"
__version__ = "1.0"

import Blender
from Blender import Mesh, Scene, Window, sys, Image, Draw
import BPyMesh
import BPyObject
import BPySys
import BPyMessages

def main():
	objects = Blender.Object.GetSelected()
	if len(objects) == 0:
		return
	
	isBody = Draw.Create(0)
	geomType = Draw.Create("box")
	mass = Draw.Create(1.0)
	hasGravity = Draw.Create(0)
	category = Draw.Create("FFFFFFFF")
	collider = Draw.Create("FFFFFFFF")
	response = Draw.Create("FFFFFFFF")
	callback = Draw.Create("00000000")
	
	pup_block = [\
	('Physics...'),\
	('is_body: ', isBody, 'Sets whether electro will update the position of this object every frame.'),\
	('geom_type: ', geomType, 0, 10, 'Sets the geom_type of this electro object.'),\
	('mass: ', mass, 1, 1000, 'The mass of this object.'),\
	('has_gravity: ', hasGravity , 'Object responds to gravity'),\
	('Classification'),\
	('category: ', category, 0, 8, 'The category of this object'),\
	('collider: ', collider, 0, 8, 'The categories this object should collide with'),\
	('response: ', response, 0, 8, 'The categories this object should respond to'),\
	('callback: ', callback, 0, 8, 'The categories of objects that this object will report a collision to do_contact')\
	]
		
	if not Draw.PupBlock('Set Electro Properties...', pup_block):
		return
	
	isBody = isBody.val
	geomType = geomType.val
	mass = mass.val
	hasGravity = hasGravity.val
	category = category.val
	collider = collider.val
	response = response.val
	callback = callback.val
	
	Window.EditMode(0)
	Window.WaitCursor(1)
	
	for o in objects:
		o.removeAllProperties()
		if isBody:
			o.addProperty("is_body",1,'BOOL')
		if geomType != "":
			o.addProperty("geom_type",geomType,'STRING')
		if mass != 0:
			o.addProperty("mass",mass,'FLOAT')
		if hasGravity:
			o.addProperty("has_gravity",1,'BOOL')
		if category != "":
			o.addProperty("category",category,'STRING')
		if collider != "":
			o.addProperty("collider",collider,'STRING')
		if response != "":
			o.addProperty("response",response,'STRING')
		if callback != "":
			o.addProperty("callback",callback,'STRING')

	Window.WaitCursor(0)
	
if __name__ == '__main__':
	main()
